package praktikum01;

public class Zahlenfilter {

    public static void main(String[] args) {
        Zahlenfilter filter = new Zahlenfilter();
        filter.filterZahlen(1, 200);
    }

    public void filterZahlen(int start, int end) {
        for (int i = start; i <= end; i++) {
            if (checkDivisibleBy5(i)) {
                System.out.println(i + " ist durch 5 teilbar!");
            }

            if (checkEndsWith9(i)) {
                System.out.println(i + " endet auf 9!");
            }

            if (checkSumDivisibleBy3(i, i - 1)) {
                int vorgaenger = i - 1;
                int summe = i + vorgaenger;
                System.out.println(i + " und " + vorgaenger + " addiert ergeben " + summe + " und " + summe + " ist durch 3 teilbar.");
            }

            if (filter(i, i - 1)) {
                System.out.println(i + " erfüllt keine der Filterkriterien.");
            }
        }
    }

    public static boolean checkDivisibleBy5(int number) {
        return number % 5 == 0;
    }

    public static boolean checkEndsWith9(int number) {
        return number % 10 == 9;
    }

    public static boolean checkSumDivisibleBy3(int number, int previousNumber) {
        return (number + previousNumber) % 3 == 0;
    }

    public static boolean filter(int number, int previousNumber) {
        return !checkDivisibleBy5(number) &&
                !checkEndsWith9(number) &&
                !checkSumDivisibleBy3(number, previousNumber);
    }
}